Option Explicit On
Option Strict Off

Imports System.Runtime.InteropServices

'---------------------------------
' EPX-18QC API library definitions
'---------------------------------

Module EPX18QC

	'
	' Device status (Return codes)
	'
    Public Const EPX18QC_OK As Integer = 0
    Public Const EPX18QC_INVALID_HANDLE As Integer = 1
    Public Const EPX18QC_DEVICE_NOT_FOUND As Integer = 2
    Public Const EPX18QC_DEVICE_NOT_OPENED As Integer = 3
    Public Const EPX18QC_OTHER_ERROR As Integer = 4
    Public Const EPX18QC_COMMUNICATION_ERROR As Integer = 5
    Public Const EPX18QC_INVALID_PARAMETER As Integer = 6


	'
	' Counter CH
	'
	Public Const EPX18QC_CNT_CH0 As Byte = 0
	Public Const EPX18QC_CNT_CH1 As Byte = 1
	Public Const EPX18QC_CNT_CH2 As Byte = 2
	Public Const EPX18QC_CNT_CH3 As Byte = 3

	'
	' Counter Mode
	'
	Public Const EPX18QC_CNT_MODE_1PHASE As Byte = 0
	Public Const EPX18QC_CNT_MODE_2PHASE As Byte = 1

	'
	' Counter Direction
	'
	Public Const EPX18QC_CNT_DIR_UP As Byte = 0
	Public Const EPX18QC_CNT_DIR_DOWN As Byte = 1

	'
	' Counter Control
	'
	Public Const EPX18QC_CNT_DISABLE As Byte = 0
	Public Const EPX18QC_CNT_ENABLE As Byte = 1

	'
	' Counter Status
	'
	Public Const EPX18QC_CNT_OK As Byte = 0
	Public Const EPX18QC_CNT_OVF As Byte = 1
	Public Const EPX18QC_CNT_UDF As Byte = 2

	'
	' Counter External Control
	'
	Public Const EPX18QC_CNT_EX_DISABLE As Byte = 0
	Public Const EPX18QC_CNT_EX_ENABLE As Byte = 1

	'
	' Counter Latch Flag
	'
	Public Const EPX18QC_CNT_LAT_FALSE As Byte = 0
	Public Const EPX18QC_CNT_LAT_TRUE As Byte = 1


	'
	' I/O Port
	'
    Public Const EPX18QC_PORT0 As Byte = 0
    Public Const EPX18QC_PORT1 As Byte = 1
    Public Const EPX18QC_PORT2 As Byte = 2

	'
	' Port Direction
	'
    Public Const EPX18QC_PORT_DIR_INPUT As Byte = 0
    Public Const EPX18QC_PORT_DIR_OUTPUT As Byte = 1


	'
	' Device Functions
	'
    Public Declare Function EPX18QC_GetNumberOfDevices Lib "EPX18QC.dll" (ByRef Number As Integer) As Integer
    Public Declare Function EPX18QC_GetSerialNumber Lib "EPX18QC.dll" (ByVal Index As Integer, ByRef SerialNumber As Integer) As Integer
    Public Declare Function EPX18QC_Open Lib "EPX18QC.dll" (ByRef Handle As System.IntPtr) As Integer
    Public Declare Function EPX18QC_OpenBySerialNumber Lib "EPX18QC.dll" (ByVal SerialNumber As Integer, ByRef Handle As System.IntPtr) As Integer
    Public Declare Function EPX18QC_Close Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr) As Integer

 	'
	' Counter Functions
	'
    Public Declare Function EPX18QC_SetCounterMode Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr, ByVal CH As Byte, ByVal Mode As Byte) As Integer
    Public Declare Function EPX18QC_GetCounterMode Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr, ByVal CH As Byte, ByRef Mode As Byte) As Integer
    Public Declare Function EPX18QC_SetCounterDirection Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr, ByVal CH As Byte, ByVal Direction As Byte) As Integer
    Public Declare Function EPX18QC_GetCounterDirection Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr, ByVal CH As Byte, ByRef Direction As Byte) As Integer
    Public Declare Function EPX18QC_SetCounterControl Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr, ByVal CH As Byte, ByVal Control As Byte) As Integer
    Public Declare Function EPX18QC_GetCounterControl Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr, ByVal CH As Byte, ByRef Control As Byte) As Integer
    Public Declare Function EPX18QC_ResetCounter Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr, ByVal CH As Byte) As Integer
    Public Declare Function EPX18QC_GetCounterValue Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr, ByVal CH As Byte, ByRef Value As Integer) As Integer
    Public Declare Function EPX18QC_GetCounterStatus Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr, ByVal CH As Byte, ByRef Status As Byte) As Integer
    Public Declare Function EPX18QC_GetCounterExControl Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr, ByVal CH As Byte, ByRef Control As Byte) As Integer
    Public Declare Function EPX18QC_GetCounterLatchFlag Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr, ByVal CH As Byte, ByRef Flag As Byte) As Integer
    Public Declare Function EPX18QC_GetCounterLatchValue Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr, ByVal CH As Byte, ByRef Value As Integer) As Integer

 	'
	' I/O Port Functions
	'
    Public Declare Function EPX18QC_SetPortDirection Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr, ByVal Port As Byte, ByVal Direction As Byte) As Integer
    Public Declare Function EPX18QC_GetPOrtDirection Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr, ByVal Port As Byte, ByRef Direction As Byte) As Integer
    Public Declare Function EPX18QC_OutputPort Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr, ByVal Port As Byte, ByVal Value As Byte) As Integer
    Public Declare Function EPX18QC_InputPort Lib "EPX18QC.dll" (ByVal Handle As System.IntPtr, ByVal Port As Byte, ByRef Value As Byte) As Integer


End Module
